HDU 5389 Zero Escape(dp解法)

题目链接:?pid=5389

题面:

Zero EscapeTime Limit: 2000/1000 MS (Java/Others)Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 164Accepted Submission(s): 73

Problem Description

Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.This is the definition of digital root on Wikipedia:The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.For example, the digital root of is , because and .In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered, the digital root of their identifier sum must be .For example, players can get into the door , but players can’t.There is two doors, numbered and . Maybe , but they are two different door.And there is players, everyone must get into one of these two doors. Some players will get into the door, and others will get into the door .For example: players are ,,There is only one way to distribute the players: all players get into the door . Because there is no player to get into the door , the digital root limit of this door will be ignored.Given the identifier of every player, please calculate how many kinds of methods are there,.

Input

The first line of the input contains a single number , the number of test cases.For each test case, the first line contains three integers , and .Next line contains integers , describing the identifier of every player.,,,

Output

For each test case, output a single integer in a single line, the number of ways that these players can get into these two doors.

Sample Input

43 9 11 2 63 9 12 3 35 2 31 1 1 1 19 9 91 2 3 4 5 6 7 8 9

Sample Output

101060

Source

2015 Multi-University Training Contest 8

解题:

开始没想到递推,队友说了下dp,往这方面想了下就想到了。状态转移方程为dp[i][j]=(dp[i-1][tmp]+dp[i-1][j])%mod;其中tmp为j-arr[i],i是当前下标,j从1到9,若算出的tmp小于等于0还需加上9。dp[i][j]的含义是到第i位为止,前i个数中的若干个加起来和为j的方案数,转移方程中的两项分别对应,当前i位取或不取。因为每个数字是由确定的两个数字组合加起来得到的,比如2,若其中一个为1,那么另外一个也一定为1。且存在这样的性质,若干个数,按给定的规则先加,或者分开加,再组合在一起,得到的结果是一样的。故可以先预先把所有的数加起来,,若其和和a+b得到的结果相同,那么直接取dp[n][a]+dp[n][b]的值即可,若不同,那么只可以放在任意门中,分别检查一下即可。

代码:

#include <iostream>#include <cstring>#include <cstdio>#define mod 258280327using namespace std;int dp[100010][10],arr[100010];//按给定规则转化为个位数int modify(int x){int res=0;while(x){res+=(x%10);x/=10;}if(res>9)return modify(res);elsereturn res;}int main(){int t,n,a,b,tmp,ans;int sum,xx;scanf("%d",&t);while(t–){sum=0;//初始化memset(dp,0,sizeof(dp));scanf("%d%d%d",&n,&a,&b);//读入for(int i=1;i<=n;i++)scanf("%d",&arr[i]);for(int i=1;i<=n;i++){//并同时转化为对应的个位数arr[i]=modify(arr[i]);sum+=arr[i];}sum=modify(sum);xx=a+b;xx=modify(xx);//看是否相等if(sum==xx){dp[1][arr[1]]=1;for(int i=2;i<=n;i++){for(int j=1;j<=9;j++){tmp=j-arr[i];if(tmp<=0)tmp+=9;//当前位分别取1-9,由前面对应的关系推过来dp[i][j]=(dp[i-1][tmp]+dp[i-1][j])%mod;}}printf("%d\n",(dp[n][a]+dp[n][b])%mod);}//不相等,只可能单独在一扇门中else{ans=0;if(sum==a)ans++;if(sum==b)ans++;printf("%d\n",ans);}}return 0;}如有疑问,欢迎交流

版权声明:本文为博主原创文章,未经博主允许不得转载。

而现在我喜欢深邃的夜空,包容一切的黑暗和隐忍,留下眼泪也没人看见。

HDU 5389 Zero Escape(dp解法)

相关文章:

你感兴趣的文章:

标签云: